# require 'rubygems'
# require 'bundler/setup'

require 'active_support/dependencies'

module Tomte
  module Agents

    LIBRARY =  File.expand_path('../..', __FILE__)
    $:.unshift LIBRARY

    SUPERVISOR_INTERFACE = "tomte.supervisor.api"

    # init bundler on the destination directory, if any-
    # require 'tomte/agents/initializer'
    # Initializer.chdir_and_bundle(ARGV)

    begin
      require 'tomte'
    rescue LoadError
      require File.expand_path('../../../../tomte-core/lib/tomte', __FILE__)
    end

    begin
      require 'tomte/protocol'
    rescue LoadError
      require File.expand_path('../../../../tomte-protocol/lib/tomte/protocol', __FILE__)
    end

    require 'tomte/agents/version'
    require 'tomte/agents/configuration'
    require 'tomte/agents/framework'

    VERSION = Tomte.read_version unless defined?(Tomte::Agents::VERSION)

    Config.add :agents, { }
    Config.add_config_files [
      {:file => 'tomte-agents.yml',
       :path => Tomte::Configuration.relative_cfg(Tomte::Agents::LIBRARY), :queue => :before},
      {:file => 'tomte-agents.yml', :path => :system }
    ]

    def self.configure! *args
      Tomte::Protocol.configure! *args
    end

  end

  module Agent
    autoload :Async,            'tomte/agent/async'
    autoload :Sync,             'tomte/agent/sync'
  end

  autoload :Network, 'tomte/network'

end









