# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

# The recommended container for all datagrams sent between
# Actors is a Tuple, defined below, and with a 'T' shortcut:

# TODO this will change soon, but I don't have the time now, L.

unless defined? Tuple

  # A Tuple class.  Will (eventually) be a subset of Array
  # with fixed size and faster performance

  class Tuple < Array #:nodoc:
    def ===(obj)
      return false unless obj.is_a? Array
      size.times { |n| return false unless self[n] === obj[n] }
      true
    end
  end
end

# Shortcut Tuple as T
T = Tuple unless defined? T
